/*
 * Copyright (c) 2010 by Intevation GmbH
 *
 * This program is free software under the LGPL (>=v2.1)
 * Read the file LGPL.txt coming with the software for details
 * or visit http://www.gnu.org/licenses/ if it does not exist.
 */

package de.intevation.gnv.artifacts;

import de.intevation.artifacts.Artifact;
import de.intevation.artifacts.ArtifactDatabase;
import de.intevation.artifacts.ArtifactDatabaseException;
import de.intevation.artifacts.ArtifactFactory;
import de.intevation.artifacts.CallMeta;

import org.w3c.dom.Document;

/**
 * @author <a href="mailto:tim.englich@intevation.de">Tim Englich</a>
 *
 */
public class TestArtifactDatabase implements ArtifactDatabase {

    private ArtifactFactory artifactFactory = null;
    /**
     * Constructor
     */
    public TestArtifactDatabase(ArtifactFactory artifactFactory) {
        this.artifactFactory = artifactFactory;
    }

    /**
     * @see de.intevation.artifacts.ArtifactDatabase#advance(java.lang.String, org.w3c.dom.Document, de.intevation.artifacts.CallMeta)
     */
    public Document advance(String artifact, Document target, CallMeta callMeta)
                                                                                throws ArtifactDatabaseException {

        return null;
    }

    /**
     * @see de.intevation.artifacts.ArtifactDatabase#artifactFactoryNamesAndDescriptions()
     */
    public String[][] artifactFactoryNamesAndDescriptions() {

        return null;
    }

    /**
     * @see de.intevation.artifacts.ArtifactDatabase#createArtifactWithFactory(java.lang.String, de.intevation.artifacts.CallMeta, org.w3c.dom.Document)
     */
    public Document createArtifactWithFactory(String factory,
                                              CallMeta callMeta,
                                              Document data)
                                                                                throws ArtifactDatabaseException {

        return null;
    }

    /**
     * @see de.intevation.artifacts.ArtifactDatabase#describe(java.lang.String, org.w3c.dom.Document, de.intevation.artifacts.CallMeta)
     */
    public Document describe(String artifact, Document data, CallMeta callMeta)
                                                                               throws ArtifactDatabaseException {

        return null;
    }

    /**
     * @see de.intevation.artifacts.ArtifactDatabase#feed(java.lang.String, org.w3c.dom.Document, de.intevation.artifacts.CallMeta)
     */
    public Document feed(String artifact, Document data, CallMeta callMeta)
                                                                           throws ArtifactDatabaseException {

        return null;
    }

    /**
     * @see de.intevation.artifacts.ArtifactDatabase#getInternalArtifactFactory(java.lang.String)
     */
    public ArtifactFactory getInternalArtifactFactory(String factoryName) {
        return this.artifactFactory;
    }

    /**
     * @see de.intevation.artifacts.ArtifactDatabase#out(java.lang.String, org.w3c.dom.Document, de.intevation.artifacts.CallMeta)
     */
    public DeferredOutput out(
        String   artifact,
        Document format,
        CallMeta callMeta)
    throws ArtifactDatabaseException {

        return null;
    }

    public DeferredOutput out(
        String   artifact,
        String   type,
        Document format,
        CallMeta callMeta)
    throws ArtifactDatabaseException
    {
        return null;

    }

    public Document process(String service, Document input, CallMeta callMeta) {
        return null;
    }

    public String[][] serviceNamesAndDescriptions() {
        return null;
    }

    public Document exportArtifact(String artifact, CallMeta callMeta) throws ArtifactDatabaseException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Document importArtifact(Document data, CallMeta callMeta) throws ArtifactDatabaseException {
        throw new UnsupportedOperationException("Not supported yet.");
    }


    public void loadAllArtifacts(ArtifactLoadedCallback callback)
    throws ArtifactDatabaseException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Artifact getRawArtifact(String identifier)
    throws ArtifactDatabaseException {
        throw new UnsupportedOperationException("Not supported yet.");
    }



    // COLLECTION API

    public Document setCollectionTTL(String collectionId, Document doc, CallMeta meta)
    throws ArtifactDatabaseException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Document setCollectionName(String collectionId, Document doc, CallMeta meta)
    throws ArtifactDatabaseException {
        throw new UnsupportedOperationException("Not supported yet.");
    }


    public DeferredOutput outCollection(String collectionId, Document format, CallMeta callMeta)
    throws ArtifactDatabaseException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public DeferredOutput outCollection(String collectionId, String type, Document format, CallMeta callMeta)
    throws ArtifactDatabaseException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    /**
     * @param collectionId
     * @param meta
     *
     * @throws ArtifactDatabaseException
     *
     * @return
     */
    public Document getCollectionsMasterArtifact(
        String   collectionId,
        CallMeta meta
    )
    throws ArtifactDatabaseException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    /**
     * @param userId
     * @param callMeta
     *
     * @throws ArtifactDatabaseException
     *
     * @return
     */
    public Document listCollections(String userId, CallMeta callMeta)
    throws ArtifactDatabaseException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    /**
     * @param ownerId
     * @param data
     * @param callMeta
     *
     * @throws ArtifactDatabaseException
     *
     * @return
     */
    public Document createCollection(
        String   ownerId,
        Document data,
        CallMeta callMeta
    )
    throws ArtifactDatabaseException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    /**
     * @param collectionId
     * @param callMeta
     *
     * @throws ArtifactDatabaseException
     *
     * @return
     */
    public Document deleteCollection(String collectionId, CallMeta callMeta)
    throws ArtifactDatabaseException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    /**
     * @param collectionId
     * @param callMeta
     *
     * @throws ArtifactDatabaseException
     *
     * @return
     */
    public Document describeCollection(String collectionId, CallMeta callMeta)
    throws ArtifactDatabaseException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    /**
     * @param collectionId
     * @param callMeta
     *
     * @throws ArtifactDatabaseException
     *
     * @return
     */
    public Document getCollectionAttribute(
        String   collectionId,
        CallMeta callMeta
    )
    throws ArtifactDatabaseException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Document setCollectionAttribute(
        String   collectionId,
        CallMeta callMeta,
        Document attribute)
    throws ArtifactDatabaseException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    /**
     * @param collectionId
     * @param artifactId
     * @param callMeta
     *
     * @throws ArtifactDatabaseException
     *
     * @return
     */
    public Document getCollectionItemAttribute(
        String   collectionId,
        String   artifactId,
        CallMeta callMeta
    )
    throws ArtifactDatabaseException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    /**
     * @param collectionId
     * @param artifactId
     * @param attribute
     * @param callMeta
     *
     * @throws ArtifactDatabaseException
     *
     * @return
     */
    public Document setCollectionItemAttribute(
        String   collectionId,
        String   artifactId,
        Document attribute,
        CallMeta callMeta
    )
    throws ArtifactDatabaseException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    /**
     * @param collectionId
     * @param artifactId
     * @param input
     * @param callMeta
     *
     * @throws ArtifactDatabaseException
     *
     * @return
     */
    public Document addCollectionArtifact(
        String   collectionId,
        String   artifactId,
        Document input,
        CallMeta callMeta
    )
    throws ArtifactDatabaseException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    /**
     * @param collectionId
     * @param artifactId
     * @param callMeta
     *
     * @throws ArtifactDatabaseException
     *
     * @return
     */
    public Document removeCollectionArtifact(
        String   collectionId,
        String   artifactId,
        CallMeta callMeta
    )
    throws ArtifactDatabaseException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    /**
     * @param collectionId
     * @param callMeta
     *
     * @throws ArtifactDatabaseException
     *
     * @return
     */
    public Document listCollectionArtifacts(
        String   collectionId,
        CallMeta callMeta
    )
    throws ArtifactDatabaseException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }


    public Document listUsers(CallMeta callMeta)
    throws ArtifactDatabaseException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Document createUser(Document data, CallMeta callMeta)
    throws ArtifactDatabaseException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    public Document deleteUser(String userId, CallMeta callMeta)
    throws ArtifactDatabaseException
    {
        throw new UnsupportedOperationException("Not supported yet.");
    }
}
